#include<iostream>
#include<cmath>
#include<iomanip>
#include<limits>

using namespace std;

double f(double x)
{
	return x*x - 4*sin(x);
}

double fprime(double x)
{
	return 2*x - 4*cos(x);
}

double newton(double x, int iterations, double tol)
{
	cout<<"x \t\t f(x) \t\t f'(x)"<<endl;
	for ( int i = 0; i < iterations; i++)
	{
		double fx = f( x );
		double fpx = fprime( x );
		cout<<setprecision(7)<<showpoint<<x<<"\t"<<fx<<"\t"<<fpx<<"\n";
		if ( fabs( fx ) < tol ) 
			return x;
		x = x - fx/fpx;
		
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}

double newton2(double x, double tol)
{
	cout<<"x \t\t f(x) \t\t f'(x)"<<endl;
	
	double fx = 10*tol;	//fx initially large to give access to loop
	while(fabs( fx )>tol)
	{
		fx = f( x );
		double fpx = fprime( x );
		cout<<setprecision(7)<<showpoint<<x<<"\t"<<fx<<"\t"<<fpx<<"\n";
		if ( fabs( fx ) < tol ) 
			return x;
		x = x - fx/fpx;
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}



int main()
{
	
	//cout<<"The solution is: "<<newton(2,20,1e-5);
	cout<<"The solution is: "<<newton2(3,1e-5);
	
	
	return 0;
}




   
   
