#include<iostream>
#include<cmath>
#include<iomanip>
#include<limits>

using namespace std;

double f(double x)
{
	return x*x - 4*sin(x);
}

double secant(double x1, double x0, int iterations, double tol)
{
	cout<<"x1 \t\t f(x1) \t\t x0 \t\t f(x0) \t\t x \t\t f(x)"<<endl;
	for ( int i = 0; i < iterations; i++)
	{
		double fx1 = f( x1 );
		double fx0 = f( x0 );
		double x = x1 - fx1*( x1 - x0 ) / ( fx1 - fx0 );
		double fx =  f(x);
		cout<<setprecision(7)<<showpoint<<x1<<"\t"<<fx1<<"\t"<<x0<<"\t"<<fx0<<"\t"<<x<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return x;
		x0 = x1;
		fx0 = fx1;
		x1 = x;
		fx1 = fx;
		
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}

double secant2(double x1, double x0, double tol)
{
	cout<<"x1 \t\t f(x1) \t\t x0 \t\t f(x0) \t\t x \t\t f(x)"<<endl;
	while(fabs(x1-x0)>tol)
	{
		double fx1 = f( x1 );
		double fx0 = f( x0 );
		double x = x1 - fx1*( x1 - x0 ) / ( fx1 - fx0 );
		double fx =  f(x);
		cout<<setprecision(7)<<showpoint<<x1<<"\t"<<fx1<<"\t"<<x0<<"\t"<<fx0<<"\t"<<x<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return x;
		x0 = x1;
		fx0 = fx1;
		x1 = x;
		fx1 = fx;
		
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}



int main()
{
	
	//cout<<"The solution is: "<<secant(1.5,2.5,20,1e-5);
	cout<<"The solution is: "<<secant2(1,3,1e-5);
	
	return 0;
}




   
   
